# 160209 - based on 16S "table_rawreads_v3.R"
setwd("~/Documents/UNI_und_VORLESUNGEN/11 phd projects/1 Meta SCHMALNAU/2 HiSeq TierMix scripts/R scripte/1 variability plot")



file_RAW <- "151009_hit_incsequ_SUB_v11_16S.csv"
file_RAW <- "tiermix_HCO_LCO_v1.csv"

height <- 6


plotme <- function(file_RAW, height=6){

subNAME <- sub(".*/", "", file_RAW)
subNAME <- sub(".csv", "", subNAME)

# compile tabel
data <- read.csv(file_RAW, stringsAsFactors=F)

data$ID.1[is.na(data$ID.1)] <- 53 # replace NA id


#aggregate by
temp <- aggregate(data[,2:11], by=list(data$ID.1), FUN="sum")

meh <- data.frame(1:53) # merge sums with undetected taxa!
temp <- merge(meh, temp, by.x= "X1.53", by.y= "Group.1", all=T)

temp[is.na(temp)] <- 0

temp2 <- temp[,c(1, 2, 11, 3, 5, 9, 7, 6, 8, 10, 4)] # sort replicates like in PLOS

IDs <- read.csv("ID_sorted.csv")[,-1]

temp3 <- temp2[IDs$ID,] # order taxa like in PLOS


write.csv(temp3, file=paste("1 PLOTS + tables/", subNAME, "_RAW.csv", sep=""))



#################
##################

#adjust gewichts


gew <- read.csv("Hit_tables_v1_weights.csv", stringsAsFactors=F)

data <- read.csv(paste("1 PLOTS + tables/", subNAME, "_RAW.csv", sep=""), stringsAsFactors=F)
temp <- data

col <- colSums(temp[,3:12], na.rm=T)

temp3 <- data
for(i in 3:12){
temp3[,i] <- temp3[,i]/col[i-2]*100
}

colSums(temp3[,3:12], na.rm=T)


percentadj <- colSums(temp3[-53, -c(1,2)], na.rm=T) # adjust percentaged divided by weight up to these % values (mahl rechnen)

# divide by weights!
temp4 <- temp3


for(i in 3:12){
temp4[-53,i] <- temp3[-53,i]/gew[,i]
temp4[-53,i] <- temp4[-53,i]*(percentadj[i-2]/sum(temp4[-53,i], na.rm=T))
}


colSums(temp4[,3:12], na.rm=T) # 

write.csv(file=paste("1 PLOTS + tables/", subNAME, "_adj.csv", sep=""), temp4)



#########################
#########################
#based on 16SvsCOi_v8_stats.R



names <- read.csv("bulk_v16_tempSUM.csv")


data <- read.csv(paste("1 PLOTS + tables/", subNAME, "_adj.csv", sep=""))

data2 <- data[53:1,]


names[,5:14][names[,5:14]>=0] <- 0

names[1,5:14] <- data2[1,4:13]
names[3:54,5:14] <- data2[2:53,4:13]

data <- names

newmean <- NULL
for (i in 1:nrow(data)){
newmean[i] <- mean(data[i,5:14][data[i,5:14]>=0.003])
}

# all
#sd(data[-1,5:14][data[-1,5:14]>=0.003])
#length(data[-1,5:14][data[-1,5:14]>=0.003])

# insects only
sd(c(log10(data[-(1:12),5:14][data[-(1:12),5:14]>=0.003])))
length(data[-(1:12),5:14][data[-(1:12),5:14]>=0.003])



# calculate deviation from expected value ~2
samples_tat_worked <- length(newmean[!is.na(newmean)]) - 1

diviate <- sqrt(c(log10(100/samples_tat_worked) - log10(newmean[newmean>0]))^2)
#sum(newmean) # mean of not 10
diviate <- diviate[-c(1:12)]



cbind(newmean)

sd(diviate, na.rm=T)

write.csv(cbind(diviate) , paste("1 PLOTS + tables/", subNAME, "_diviate_2%.csv", sep=""))


# report from loop                                                                             
print(file_RAW)
#print("all")
#print((sd(data[-1,5:14][data[-1,5:14]>=0.003])))
print("insects_only")
print(sd(log10(data[-(1:12),5:14][data[-(1:12),5:14]>=0.003])))
print(paste("precision - log10 diviation from", 100/samples_tat_worked))
print(sd(diviate, na.rm=T))
print("")

newmean[is.na(newmean)] <- 0


data <- cbind(data, "mean"= newmean)
data <- data[54:1,]

data[54,]
sum(data[54, 5:14])/10
sd(data[54, 5:14])

#write venn diagramm file!
##################
huhu <- NULL
for (i in c(1:52)){
huhu[i] <- sum(!data[i, 5:14]>=0.003)
}
write.csv(huhu , paste("Venn diagram/", subNAME, "_venn.csv", sep=""))


# start plot!

pdf(file=paste("1 PLOTS + tables/", subNAME, "_plot.pdf", sep=""), width=10, height= height, useDingbats=FALSE)

plot(-10, ylim=c(0.001,50), xlim=c(1,54), xaxt="n", yaxt="n", xlab="", log="y", ylab="% sequences per specimen", main= subNAME)

lines(c(-4,58), c(10,10), col="Gray")
lines(c(-4,58), c(1,1), col="Gray")
lines(c(-4,58), c(0.1,0.1), col="Gray")
lines(c(-4,58), c(0.01,0.01), col="Gray")
lines(c(-4,58), c(0.003,0.003), col="Red")
lines(c(-4,58), c(0.0015,0.0015))
lines(c(-4,58), c(100/samples_tat_worked, 100/samples_tat_worked), col="Blue")


i <- 1

meep <- NULL
for (i in c(1:54)){
meep[i] <- sum(!data[i, 5:14]>=0.003)
}
meep <- which(meep<10) # count points over 0.003


data1 <- data[,5:14]
data1[data1<0.003] <- NA


for (k in 1:54){
rect(meep[k]-0.4, min(data1[meep[k],], na.rm=T), meep[k]+0.4, max(data1[meep[k],], na.rm=T), col="Lightgray", border=F)
}


for (i in 1:10){
points(which(data[i+4]>=0.003), data[i+4][data[i+4]>=0.003], pch=16, cex=0.5, col="Black")
}

for (i in 1:10){
points(which(data[i+4]>=0.0015&data[i+4]<0.003), data[i+4][data[i+4]>=0.0015&data[i+4]<0.003], pch=16, cex=0.5, col="Gray")
}



points(which(data$mean>=0.003), data$mean[data$mean>=0.003], col="Red") # add mean!
axis(1, at=c(1:52,54), labels=F)


mix_italic <- data$Rital
mix_italic[mix_italic==T] <- 3 
mix_italic[mix_italic==F] <- 1 
mix_italic <- as.numeric(mix_italic)

text(cex=0.5, 1:54+.75, y=0.0004, data$Mix, xpd=TRUE, srt=45, pos=2, font= mix_italic) # add taxa lables

axis(2, at= c(0.01, 0.1, 1, 10), labels=c(0.01, 0.1, 1, 10), las=2)

#points(which(data$mean<0.003), rep(0.001, length(which(data$mean<0.003))), col="Grey")

mycol <- c("Orange", "Orange", "Orange", "Orange", "Orange", "Orange", "Orange", "Orange", "Orange", "Red")

for (i in c(1:52, 54)){
meep <- sum(!data[i, 5:14]>=0.003)
if(meep>0){text(i, 0.001, meep, cex=0.7, col=mycol[meep])}
}

text(-1, 0.003, "0.003% cut off", cex=0.5, xpd=TRUE, pos=2, font=2, col="Red")
text(-1, 0.001, "Number of\nundetected\nspecimens", cex=0.5, xpd=TRUE, pos=2, font=2, col="Black")
text(-1, 100/samples_tat_worked, "exp. abund.", cex=0.5, xpd=TRUE, pos=2, font=2, col="Blue")

dev.off()

}


plotme("../../7 BOLD/OTU_BF2_BR2/OTU_BF2_BR2_taxo_v5.csv", 4.5)

plotme("../../7 BOLD/OTU_BF1_BR1/OTU_BF1_BR1_taxo_v2.csv", 4.5)
#warnings()

plotme("../../7 BOLD/OTU_BF1_BR2/OTU_BF1_BR2_taxo_v3.csv", 4.5)

plotme("../../7 BOLD/OTU_BF2_BR1/OTU_BF2_BR1_taxo_v3.csv", 4.5)

plotme("tiermix_HCO_LCO_v1.csv", 6)
#warnings()

plotme("151009_hit_incsequ_SUB_v11_16S.csv", 6)
#warnings()
